<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\QuestionRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Question;
use App\Answer;

class QuestionController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/questions';
    /** View folder */
    private $viewDirectory= 'admin.questions.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('questions.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the questions.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Question::orderBy('id', 'DESC')->where('answer_id',null);

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->question) {
            $query->where('question', 'LIKE', '%'.$request->question.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $questions= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('questions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('questions.store');
        $head = metaFields('questions', 'add_new', getCurrentLocale()) ?? __('questions.new');
        
       

        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param QuestionRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(QuestionRequest $request) :RedirectResponse
    {
     
        $question= Question::create($request->all());
       
         $this->saveData( $request, $question->id );
       
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Question  $question
     * @return View
     */
    public function edit(Question $question): View
    {
        $action= route('questions.update', $question->id);
        $head = metaFields('questions', 'edit', getCurrentLocale()) ?? __('questions.edit');
        $answers = Answer::where('question_id',$question->id)->get();


        return view( $this->viewDirectory.'form', compact('question', 'action', 'head','answers') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  QuestionRequest  $request
     * @param  Question  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(QuestionRequest $request, Question $question) :RedirectResponse
    {
      
        $question->update($request->all());
        $answers = Answer::where('question_id',$question->id)->pluck('id');
         Answer::where('question_id',$question->id)->delete();
         Question::whereIn('answer_id',$answers)->delete();
          $this->saveData( $request, $question->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    
    private function saveData(QuestionRequest $request, int $question_id ) :void
     {

       

        if($request->questions){
            foreach($request->questions as $row){
               $answer = Answer::create([
                    'question_id'=>$question_id,
                    'answer'=>$row['answer']
                    ]);
                    
                    if(isset($row['questions'])){
                     foreach($row['questions'] as $value){
                      $question = Question::create([
                    'answer_id'=>$answer->id,
                    'question'=>$value['question'],
                    ]); 
                    if(isset($value['answers'])){
                         foreach($value['answers'] as $rows){
                      Answer::create([
                    'question_id'=>$question->id,
                    'answer'=>$rows['answer'],
                    ]); 
                             
                         }
                    }
                     }
                     }
            }
            
        }
     }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Question::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Question::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Question::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Question::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Question::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
